==================
Terminology 1.14.0
==================

Changes since 1.13.0:
---------------------

Additions:
    * New translations: Hungarian, Slovak
    * Report or Set Selection through escape codes
    * Handle Alternate Escape (7728)
    * Handle Application Escape Code
    * Add configuration whether emojis should be considered as double width.
      Default is double width.
    * Colorshemes: add GruvBox Material Dark

Improvements:
    * Translation updates for Chinese (Simplified), Catalan, Croatian, Dutch,
      Finnish, French, Indonesian, Japanese, Lithuanian, Polish, Portuguese,
      Portuguese (Brazil), Russian, Serbian, Spanish, Swedish, Turkish
    * Unify format of responses to OSC 10, 11 and 12

Fixes:
    * Fix translucent background on startup
    * Fix wheel events emitted even if wheel has not moved
    * Do not use spaces when returning terminal name
    * Colorschemes: ensure metadata.name and file name are the same
    * Fix issue when exiting on *BSD
    * Do not interpret "CSI = 5 u" as DECRC
    * Handle empty CSI SRG 38/48
    * Do not consider Key Resources as color

Internal improvements:
    * Build with Meson 0.59 or later
    * Cleanup the code base about misuse of calloc()
    * Testing on OSC 52


Changes since 1.12.1:
---------------------

Additions:
    * Colorshemes: add Fir Dark, Selenized Dark, Selenized Black,
      Selenized Light and Selenized White schemes
    * New translations: Indonesian

Improvements:
    * Translation updates for Catalan, Chinese (Simplified), Croatian, Dutch,
      French, German, Italian, Portuguese, Portuguese (Brazil),
      Russian, Spanish, Swedish, Turkish
    * Handle scale changes on the fly
    * Better named option to enable/disable typing sounds
    * Improved README file
    * The tyls tools now supports pls files
    * Fade the background of the terminal with the background color defined in
      the color scheme
    * Update the default theme to customize selection arrows
    * Update color schemes about selection arrows
    * Better documentation of the tyalpha tool

Fixes:
    * Fix issue when restoring the cursor state
    * Fix issue preventing some red color from being displayed

Internal improvements:
    * Cleanup the code base about C reserved identifiers
    * Code analyzed with Coverity 2022.06
    * Test code with some Coccinelle script in the GitHub's CI
    * Update the ChangeLog.theme file


Changes since 1.12.0:
---------------------

Fixes:
    * Build and install Default colorscheme
    * Correctly set the version


Changes since 1.11.0:
---------------------

Additions:
    * New default theme!

Improvements:
    * Support EFL 1-26 or newer only
    * Colorschemes generate their own configuration file, allowing for easy
      management of outside contributions


Changes since 1.10.0:
---------------------

Additions:
    * Support for focus reporting escape codes

Improvements:
    * Translation updates for Finnish and Ukrainian

Fixes:
    * Fix handling of escape code OSC 11


Changes since 1.9.0:
--------------------

Additions:
    * Colorshemes: add Black scheme
    * New translations: Sinhala, Hebrew

Improvements:
    * Translation updates for Chinese (Simplified), Croatian, Danish, French,
      Greek, Italian, Norwegian Bokmål, Polish, Portuguese,
      Portuguese (Brazil), Russian, Spanish, Swedish, Ukrainian
    * Focus font search in the Font settings panel

Fixes:
    * Fix issue when configuration was marked as Temporary
    * Stop jumping down to the botton when configuration changed
    * Respect login shell on start
    * Fix drag'n'drop of paths or media on the terminal
    * Fix libintl detection


Changes since 1.8.1:
--------------------

Additions:
    * Colorshemes: easily change the colors of the terminal
    * Add the following color schemes: Tango Dark, Tango light, Dracula,
      Belafonte Day, Belafonte Night, Material, Fahrenheit, Tomorrow Night
      Burns, PaleNight, Soft Era, One Dark, Cobalt2
    * New translations: Chinese (Simplified), Japanese, Norwegian Bokmål,
      Russian and Ukrainian
    * Handle OSC 12 to change the cursor color

Improvements:
    * Translation updates for Catalan, Croatian, Danish, Dutch, French,
      German, Italian, Spanish
    * Add font search in the fonts panel
    * Set TERM to xterm_256color by default
    * Focus simplifications when going into the settings
    * Tests: better compatibility with debian-based systems

Fixes:
    * Fix tyls with png/jpg thumbnails


Changes since 1.8.0:
--------------------

Fixes:
    * Be stricter on which characters can be considered wide or not
    * Apply change about hiding mouse pointer after idle time on all terminals


Changes since 1.7.0:
--------------------

Additions:
    * Small framework to add unit tests
    * Display tooltips on when hovering color descriptions
    * Handle OSC 10/11 to change/get background and foreground colors

Improvements:
    * Reworked build system for testing and fuzzing
    * Use of switch-case constructs when home-made binary search was not
      efficient
    * Support EFL 1-22 or newer only
    * Larger list of word separators when doing word-selection
    * Reworked the Settings panel to add one panel on Mouse interactions
    * Handle Emoji characters as double-width, following Unicode 13.0

Fixes:
    * Fix issues detected by UndefinedBehavior Sanitizer


Changes since 1.6.0:
--------------------

Additions:
    * Terminology is packaged on the snapstore at https://snapcraft.io/terminology
    * Add THEME.md, a documentation file on theming Terminology
    * Drag tabs to reorder them
    * Dragging tabs outside the tab bar can be used to create new splits or
      tabs
    * Add Croatian translation
    * Handle escape code used to display terminal program and version
    * Set environment variables TERM_PROGRAM and TERM_PROGRAM_VERSION

Improvements:
    * Memory accounting of the backlogs. Seen under the Behavior tab on the
      Settings panel
    * Handle escape codes to stack titles
    * Tyls: add icon for flac files
    * Update the mild-based themes to be on-par feature-wise with the default
      theme
    * Tab selector shows background color
    * Controls panel is hidden when creating new tab or split
    * Enable Grouped Input from the Controls panel
    * Show special icon on tab when using Grouped Input
    * Add option to decide whether Grouped input goes to all tabs or only
      visible ones
    * Improve email/links detection when surrounded with special characters
    * Remove link underline when the link disappears
    * Share translucent / opacity setting accross all instances
    * Use a default icon of each tab on the Settings toolbar
    * Update french, german, italian and serbian translations

Removals:
    * Removed video settings

Fixes:
    * Handle invalid values on OS escape codes
    * Better handle reads and writes on EINTR/EAGAIN


Changes since 1.5.0:
--------------------

Additions:
    * Show title tab on splits, depending on configuration
    * Show tabs that had a bell rang and had not been focused
    * Add wizard on new configuration to set scaling
    * Add scale configuration in the Settings panel
    * Add Polish translation

Improvements:
    * Themes: make tab title readable based on theme default colors
    * Move the tab selector on the tab line
    * Be able to select and copy tabs
    * Better handle stalled unix socket when using one terminology with
      multiple instances
    * Change typop behavior to queue files in case there are multiple files to
      look at
    * Update Italian translation

Fixes:
    * Fix live selections in the scrollback
    * Fix unchecking "auto-hide cursor" not working
    * Fix memory leaks related to looking for links under the mouse
    * Ensure Terminology compiles with EFL-1.20
    * Fix link detection over spaces
    * Fix tab selector no longer taking into account the new destination
    * Fix crash when using typop with multiple files
    * No longer set environment variable DESKTOP_STARTUP_ID as it may no
      longer be accurate
    * Allow tabs to be pasted


Changes since 1.4.1:
--------------------

Additions:
    * Handle emoji has double-width character, introduced in Unicode 9.0.
    * Add option "Treat Emojis as double-width characters", on by default.
    * Hide cursor when idle, with parameter to set idle time
    * Add papercolor theme

Improvements:
    * Themes can now set background color through a color-class
    * Handle OSC-11 to report background color
    * Update Italian and French translations

Fixes:
    * Fix initial window size hints
    * Fix focus issues


Changes since 1.4.0:
--------------------

Fixes:
    * Decode pasted string as UTF-8, fixing some characters being skipped
    * Fix theme to ensure default size is 80x24
    * Fix focus disappearing after going to Settings and back


Changes since 1.3.2:
--------------------

Additions:
    * Add Continuous Integration on every push to the git repository
    * Add a test framework on escape code parsing and interpreting
    * Add more than 120 test files
    * Add support, along with tests, for the following escape codes: DSR-DIR,
      DSR-KBD, DSR-MSR, DSR-DECCKSR, DSR-OS, DSR-PP, DSR-UDK, DECSCLM, DECBI,
      DECFI, DECSACE, DECRARA, DECCRARA, DECIC, DECDC, DECCRA, DECST8C, DA3,
      DECSWBV
    * Add finer configuration on whether to activate links
    * Set environment variable WINDOWID

Improvements:
    * Selections only disappear if the underlaying content changes
    * When pasting a buffer, skip control characters as a security measure

Fixes:
    * Fixes, along with tests, on handling the following escape codes: VPR,
      DECERA, DECFRA, DSR-CPR, DCH, DECALN, DECAWM, IL, DL
    * Fixes, along with tests, on mouse reporting
    * Fixes on issues spotted by Coverity


Changes since 1.3.1:
--------------------

Fix:
    * Clicking on links works again


Changes since 1.3.0:
--------------------

Addition:
    * Add manpages on Terminology's helpers

Fixes:
    * Do not popup unknown media types (security issue)
    * Right-click on hyperlinks no longer crashes


Changes since 1.2.1:
--------------------

Additions:
    * Hyperlink escape code support

Improvements:
    * Optimize escape code parsing by improving cell copies

Fixes:
    * Fix issues about settings panel
    * Do not pass input when tab selector is up
    * Escape code fixes


Changes since 1.2.0:
--------------------

Fixes:
    * Fix focus issues when input was not registering
    * User-defined tab titles stay even when terminal wants change it
    * Themes no longer have glow when unfocused


Changes since 1.1.1:
--------------------

Additions:
    * New build system based on Meson
    * Add Nord theme
    * Add tysend tool and support escapes for sending single files
    * Grouped input support with Alt+g and Alt+Shift+g
    * Different cursor shapes: block (default), underline and bar

Improvements:
    * Support REP (Repeat preceding character) escape code
    * Support HPA (Horizontal Position Absolute) escape code
    * Support encircled escape code (SGR 52)
    * Support DECSCUSR (changing cursor shape)
    * When grabbing images through gravatar, use https
    * Shine level is configurable
    * Support EFL 1.20 or newer only
    * Approximate true-colors

Fixes:
    * Escape code fixes
    * More focus fixes


Changes since 1.1.0:
--------------------

Additions:
    * Danish translation

Fixes:
    * Fix issues with bottom margins
    * No longer add spurious newlines in selections in the backlog
    * No longer add space when running command from -e option
    * Fix -T option to set the title of the window


Changes since 1.0.0:
--------------------

Additions:
    * Double-click on tab title to change it
    * Add option to disable focus-in/out animations and visuals
    * Add option to set current window size as default.
    * Support Right/Left Margins
    * Support for the DECERA/DECFRA escape codes
    * Move cursor to position on Click+Alt
    * Add binding (Alt+Up/Down/Left/Right) to move around panes

Improvements:
    * Fallback to ~ or / when creating new term if current dir is not available
    * Support only efl >= 1.8.0
    * Harden escape codes decoding
    * Update all terms of a window when changing font (name or size)
    * Remove teamwork feature

Fixes:
    * Correctly handle the DECOM, DECSTBM, DECSLRM escape codes
    * Fix crash when resizing and there are tabs in content
    * Fix mouse motion and mouse button reporting
    * Set window sizing to 1xp step when having visible tabs


Changes since 0.9.1:
--------------------

Additions:
    * Bold/Italic support (on by default)

Improvements:
    * Add keybinding shift+home to go to the top of the backlog
    * Add keybinding shift+end to reset scroll
    * Add keybinding shift+left/right to switch between tabs
    * Add keybinding ctrl+alt+t to change terminal's title
    * Add ability to copy links on right-click menu
    * Font size can be changed by escape sequence
    * Rewrite link detection to be more efficient
    * Sanitize SHELL environment variable when using it

Fixes:
    * Fix selections
    * Fixes about escape sequences managing tabs
    * Many fixes


Changes since 0.9.0:
--------------------

Improvement:
    * Handle Ctrl-[2-8] when tab key bindings are removed

Fixes:
    * Fix resizing issue
    * Fix solarized theme


Changes since 0.8.0:
--------------------

Additions:
    * Add keybing to fullscreen Terminology
    * Right click on selection to be able to copy/open it
    * Add meta/hyper to key bindings
    * Add option to always show miniview
    * Add option to disable terminology escape codes

Improvements:
    * Add -a option to tyls to display hidden files
    * tybg without arguments restores the default wallpaper
    * Escape closes media popup
    * Terminology works on solaris
    * Font selector now displays previews with current theme colors
    * Try to get mime type when displaying URLs
    * Do not use ':' as word separator but trim it from word selections
    * Improved resizing handling

Fixes:
    * Various bug fixes


Changes since 0.7.0:
--------------------

Additions:
    * Gravatar support
    * Visual tab bar
    * xterm "notification" support

Improvements:
    * Display pre-edit text when composing
    * Selection improvements

Fixes:
    * Various bug fixes


Changes since 0.6.1:
--------------------

Additions:
    * Internationalization and Localization support
    * Options -S/--split to start terminology with multiple splits
    * Configurable key bindings
    * Add a panel to launch elementary_config

Improvements:
    * Opacity level can be configured in translucent mode
    * Miniview: add position indicator
    * Improve media controls
    * Use a scalable font on default configuration
    * Usual round of improvements on terminal compatibility

Fixes:
    * Fix issue with mute option
    * Various bug fixes


Changes since 0.6.0:
--------------------

Additions:
    * Add .tga images to recognized files

Improvements:
    * Reduced power consumption

Fixes:
    * Fix issues with the teamwork modules and popups


Changes since 0.5.1:
--------------------

Additions:
    * Make term switching cyclic
    * Add Mouse-Over focus
    * Fraktur support
    * Add option whether to detect links
    * Add option to disable the sound of the bell
    * Add new themes: Nyanology and smyck
    * Add miniview feature

Improvements:
    * Improve terminal compatibility
    * Improve font selector to be able to select different font styles
    * Support rotation metadata on media files

Fixes:
    * Various bug fixes


Changes since 0.5.0:
--------------------

Fixes:
    * Make terminology compatible with upcoming efl/elm 1.10
    * Fix disappearing prompt on resize


Changes since 0.4.0:
--------------------

Additions:
    * Color settings panel
    * Wallpaper settings panel
    * Load themes from ~/.config/terminology/themes/
    * Add a new theme: base16_ocean_dark

Improvements:
    * Better default configuration
    * Improve terminal compatibility

Fixes:
    * Many bugs fixes


Changes since 0.3.0:
--------------------

Additions:
    * Add a man page
    * Text reflow
    * Add option to set geometry on start
    * Audio keyboard
    * Inline edje objects

Improvements:
    * Compress backscroll
    * Improve terminal compatibility
    * 256-colors support
    * Selection handling

Fixes:
    * Many bugs fixes
